% by sanja, ttic

try
    ROOT = '..';
    %ROOT = [your path goes here];
catch
    fprintf('set the paths in view_annot.m!\n');
end;
IMAGES_PATH = fullfile(ROOT, 'Images');
ANNOTATION_PATH = fullfile(ROOT, 'Annotations');

annot_path = ANNOTATION_PATH;
annotationfileformat = fullfile(annot_path, '%s.mat');
annotationfileformat = strrep(annotationfileformat,'\','\\');
imfileformat = fullfile(IMAGES_PATH, '%s.bmp');
imfileformat = strrep(imfileformat,'\','\\');
fileformats.annotationfileformat = annotationfileformat;
fileformats.imfileformat = imfileformat;

imfiles = dir(fullfile(IMAGES_PATH, '*_s.bmp'));
for i = 1 : length(imfiles)
    [~,imname, ext] = fileparts(imfiles(i).name);
    imfiles(i).imname = imname;
end;

n_objects = length(imfiles);
im_num = 1;
obj_num = 1;

%width = 1350;
width = 900;
height = 600;
h_f = figure('Position',[80 150 width height]);
%set(h_f, 'Color', [1, 1, 1])
h_a = axes('Position',[0.01 0.04 0.99 1]); axis off;
whitebg('k');


xl = 0.005;
yt = 0.00;
wf = 1;
control_height = 70 / height;
hf = 1 - control_height - 0.03;
text_pos = 45;
fontsize = 9;
control_col = [0.1,0.1,0.18];
text_col = [0.7,0.2,0.3];
box2D_color = [0.8,1,0.1];
slider_height = 30;
dowhite = 0;

pos_fig = [xl, control_height + yt, wf, hf; xl + wf, control_height + yt, 1-wf-xl, hf; xl, yt, 1, control_height];

hall = uipanel('BackgroundColor',[0,0,0],'ForegroundColor',[0,0,0],...
             'Position',[0,0,1,1]);  
         
hImage = uipanel('Title', ['Image:  ' imfiles(im_num).imname], 'FontSize',12,...
             'BackgroundColor',[0,0.,0.],'ForegroundColor',[1,1,1],...
             'Position',pos_fig(1,:),'Parent',hall);  
         
h3D = [];
hClass = [];
hcontrols = uipanel('FontSize',12,'HighlightColor',control_col,'BorderWidth',2,...
 'BackgroundColor',control_col,'BorderType','line',...
 'Position',pos_fig(3, :)); 
  
%---------------------------------------------------
% plot the image
h1=subplot('Position',[0.04,0.04,0.94,0.94],'Parent', hImage);
%---------------------------------------------------
h2 = [];

% set up handles
handles = [];
handles.h1 = h1;
handles.h2 = h2;
handles.hImage = hImage;
handles.hClass = [];

show.show2dbox = 1;
show.showall = 1;

%---------------------------------------------------
% colors
col.box2dcol = [1,1,0];
col.box2dcol_na = [1,0.4,0.4];
col.annot_col = [1,0.8,0];
col.annot_col_na = [1,0.2,0.2];
%---------------------------------------------------

% image data
%-------------
data = [];
show.im_num = im_num;
data = objects_loadim(fileformats, imfiles, im_num, obj_num, data, handles, show, col);
annotation = data.annotation;
scene_label = annotation.scene_label;
subplot(handles.h1);
% display


big_button_spacing = 14;
small_button_spacing = 4;
%-----------------------------------------
% images
pos = 10; w = 45;              
uicontrol('Style', 'pushbutton', 'String', '<<', ...
          'Position', [pos 10 w 30], ... 
          'Callback', ['im_num = mod(im_num - 2, length(imfiles)) + 1;' ...
                       'data = [];'...
                       'data = objects_loadim(fileformats, imfiles, im_num, obj_num, data, handles, show, col);'...
                       'annotation = data.annotation;'...
                       'set(hClass, ''String'', annotation.class{obj_num});'...
                       'if isfield(annotation,''scene_label'') & ~isnumeric(annotation.scene_label), scene_label = annotation.scene_label; try, set(hScenetype, ''BackgroundColor'', [0.4,0.6,1]); end; end;'...
                       'annotation.scene_label = scene_label;'...
                       'try, set(hScenetype,''String'', scene_label); end;'...                  
                       ]);
                   
uicontrol('style','text','string','image','position',[pos,  text_pos, 2* w + small_button_spacing, 16],'fontsize',fontsize, 'BackgroundColor', text_col, 'ForegroundColor', [1,1,1]); 
                   
pos = pos + w + small_button_spacing;                   
uicontrol('Style', 'pushbutton', 'String', '>>', ...
          'Position', [pos 10 w 30], ... 
          'Callback', ['im_num = mod(im_num, length(imfiles)) + 1;' ...
                       'data = [];'...
                       'data = objects_loadim(fileformats, imfiles, im_num, obj_num, data, handles, show, col);'...
                       'annotation = data.annotation;'...
                       'set(hClass, ''String'', annotation.class{obj_num});'...
                       'if isfield(annotation,''scene_label'') & ~isnumeric(annotation.scene_label), scene_label = annotation.scene_label; try, set(hScenetype, ''BackgroundColor'', [0.4,0.6,1]); end; end;'...
                       'annotation.scene_label = scene_label;'...
                       'try, set(hScenetype,''String'', scene_label); end;'...                        
                       ]);
%-----------------------------------------        
                  
                 
pos = pos + w + small_button_spacing; 
w = 80;
uicontrol('style','text','string','scene type','position',[pos,  text_pos, w, 16],'fontsize',fontsize, 'BackgroundColor', text_col, 'ForegroundColor', [1,1,1]); 
hScenetype = uicontrol('Style', 'edit', 'String', scene_label, 'BackgroundColor', [0.4,0.6,1],'fontsize',10,'fontweight', 'bold',...
          'Position', [pos 10 w 30], ... 
          'Callback', ['scene_label = get(hScenetype,''String'');' ...
                       ]);  
             
%-----------------------------------------
% viz  
pos = pos + w + small_button_spacing; 
ws = 80;
w = ws(1);    
uicontrol('style','text','string','display','position',[pos,  text_pos, (sum(ws) + small_button_spacing*(size(ws, 1) - 1)), 16],'fontsize',fontsize, 'BackgroundColor', text_col, 'ForegroundColor', [1,1,1]); 
hShowBox2D = uicontrol('Style', 'radiobutton', 'String', 'bbox2D', 'Value', show.show2dbox, 'ForegroundColor', [1,1,1], ...
          'Position', [pos 10 w slider_height], ... 
          'Callback', ['show.show2dbox = get(hShowBox2D, ''Value'');'...
                       'view_objects_plots(handles.h1, handles.h2, handles.hImage, data.im, annotation, obj_num, show, col, data);'...
                      ]);
                  
%-----------------------------------------



w = 65; 
pos = width - w - 10;    
uicontrol('Style', 'pushbutton', 'String', 'Exit', ...
          'Position', [pos 10 w 30], ... 
          'Callback', 'close all;');